package net.projectmonkey.object.mapper.analysis;

import net.projectmonkey.object.mapper.analysis.cache.PropertiesCacheKey;
import net.projectmonkey.object.mapper.analysis.result.PropertyMapping;
import net.projectmonkey.object.mapper.analysis.cache.MappingsCacheKey;
import net.projectmonkey.object.mapper.analysis.result.PropertyPaths;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/*
 *
 *  * Copyright 2012 the original author or authors.
 *  *
 *  * Licensed under the Apache License, Version 2.0 (the "License");
 *  * you may not use this file except in compliance with the License.
 *  * You may obtain a copy of the License at
 *  *
 *  *      http://www.apache.org/licenses/LICENSE-2.0
 *  *
 *  * Unless required by applicable law or agreed to in writing, software
 *  * distributed under the License is distributed on an "AS IS" BASIS,
 *  * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  * See the License for the specific language governing permissions and
 *  * limitations under the License.
 *
 */

/**
 * @author Andy Moody
 */
public class MappingCache
{

	private Map<MappingsCacheKey, List<PropertyMapping>> mappingsCache = new HashMap<MappingsCacheKey, List<PropertyMapping>>();
	private Map<PropertiesCacheKey, PropertyPaths> propertiesCache = new HashMap<PropertiesCacheKey, PropertyPaths>();

	public void addMappings(MappingsCacheKey key, List<PropertyMapping> mappings)
	{
		mappingsCache.put(key, mappings);
	}

	public boolean containsMappings(final MappingsCacheKey cacheKey)
	{
		return mappingsCache.containsKey(cacheKey);
	}

	public List<PropertyMapping> getMappings(final MappingsCacheKey cacheKey)
	{
		return mappingsCache.get(cacheKey);
	}

	public void addProperties(PropertiesCacheKey key, PropertyPaths paths)
	{
		propertiesCache.put(key, paths);
	}

	public boolean containsProperties(final PropertiesCacheKey cacheKey)
	{
		return propertiesCache.containsKey(cacheKey);
	}

	public PropertyPaths getProperties(final PropertiesCacheKey cacheKey)
	{
		return propertiesCache.get(cacheKey);
	}
}
