package net.projectmonkey.object.mapper.analysis.duplicates;

import net.projectmonkey.object.mapper.analysis.result.PropertyPath;

import java.util.Collection;
import java.util.List;

/*
 *
 *  * Copyright 2012 the original author or authors.
 *  *
 *  * Licensed under the Apache License, Version 2.0 (the "License");
 *  * you may not use this file except in compliance with the License.
 *  * You may obtain a copy of the License at
 *  *
 *  *      http://www.apache.org/licenses/LICENSE-2.0
 *  *
 *  * Unless required by applicable law or agreed to in writing, software
 *  * distributed under the License is distributed on an "AS IS" BASIS,
 *  * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  * See the License for the specific language governing permissions and
 *  * limitations under the License.
 *
 */

/**
 * @author Andy Moody
 */
public final class ErrorOnDuplicatesBehaviour implements DuplicateMappingBehaviour
{

	public static final ErrorOnDuplicatesBehaviour INSTANCE = new ErrorOnDuplicatesBehaviour();

	private ErrorOnDuplicatesBehaviour(){}

	@Override
	public <T extends PropertyPathAndTokens> List<PropertyPath> filterDestinationsBySource(final T sourcePath, final Collection<T> matchingDestinations)
	{
		throw new IllegalStateException("duplicate destination paths found for source "+ sourcePath);
	}

	@Override
	public <T extends PropertyPathAndTokens> PropertyPath filterSourcesByDestination(final T destinationPath, final Collection<T> matchingSources)
	{
		throw new IllegalStateException("duplicate source paths found for destination "+ destinationPath);
	}
}
