package net.projectmonkey.object.mapper.analysis.token.matcher;

/*
 *
 *  * Copyright 2012 the original author or authors.
 *  *
 *  * Licensed under the Apache License, Version 2.0 (the "License");
 *  * you may not use this file except in compliance with the License.
 *  * You may obtain a copy of the License at
 *  *
 *  *      http://www.apache.org/licenses/LICENSE-2.0
 *  *
 *  * Unless required by applicable law or agreed to in writing, software
 *  * distributed under the License is distributed on an "AS IS" BASIS,
 *  * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  * See the License for the specific language governing permissions and
 *  * limitations under the License.
 *
 */

/**
 * @author Andy Moody
 */
import java.util.Comparator;

public enum MatchStrength{
	EXACT(0),
	IGNORING_CASE(1),
	IGNORING_TOKEN_POSITION(2),
	IGNORING_CASE_AND_TOKEN_POSITION(3),
	IGNORING_PROPERTY_POSITION(4),
	IGNORING_CASE_AND_PROPERTY_POSITION(5),
	IGNORING_PROPERTY_AND_TOKEN_POSITION(6),
	IGNORING_CASE_AND_PROPERTY_AND_TOKEN_POSITION(7),
	PARTIAL(8),
	NONE(100);

	private int priority;

	private MatchStrength(final int priority){
		this.priority = priority;
	}

	public int getPriority() {
		return priority;
	}

	public static class MatchStrengthPriorityComparator implements Comparator<MatchStrength>{

		@Override
		public int compare(final MatchStrength arg0, final MatchStrength arg1) {
			return arg0.priority - arg1.priority;
		}

	}

}
