package net.projectmonkey.object.mapper.analysis.token.matcher;

/*
 *
 *  * Copyright 2012 the original author or authors.
 *  *
 *  * Licensed under the Apache License, Version 2.0 (the "License");
 *  * you may not use this file except in compliance with the License.
 *  * You may obtain a copy of the License at
 *  *
 *  *      http://www.apache.org/licenses/LICENSE-2.0
 *  *
 *  * Unless required by applicable law or agreed to in writing, software
 *  * distributed under the License is distributed on an "AS IS" BASIS,
 *  * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  * See the License for the specific language governing permissions and
 *  * limitations under the License.
 *
 */

/**
 * @author Andy Moody
 */
public class PartialTokenMatch
{
	protected final MatchStrength strength;
	protected final Integer sourceTokenPosition;
	protected final Integer destinationTokenPosition;

	public PartialTokenMatch(final MatchStrength strength, final Integer sourceTokenPosition, final Integer destinationTokenPosition)
	{
		this.sourceTokenPosition = sourceTokenPosition;
		this.strength = strength;
		this.destinationTokenPosition = destinationTokenPosition;
	}

	public MatchStrength getStrength()
	{
		return strength;
	}

	public Integer getSourceTokenPosition()
	{
		return sourceTokenPosition;
	}

	public Integer getDestinationTokenPosition()
	{
		return destinationTokenPosition;
	}

	@Override
	public String toString()
	{
		return "PartialTokenMatch{" +
				"strength=" + strength +
				", sourceTokenPosition=" + sourceTokenPosition +
				", destinationTokenPosition=" + destinationTokenPosition +
				'}';
	}
}
