package net.projectmonkey.object.mapper.context;

/*
 *
 *  * Copyright 2012 the original author or authors.
 *  *
 *  * Licensed under the Apache License, Version 2.0 (the "License");
 *  * you may not use this file except in compliance with the License.
 *  * You may obtain a copy of the License at
 *  *
 *  *      http://www.apache.org/licenses/LICENSE-2.0
 *  *
 *  * Unless required by applicable law or agreed to in writing, software
 *  * distributed under the License is distributed on an "AS IS" BASIS,
 *  * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  * See the License for the specific language governing permissions and
 *  * limitations under the License.
 *
 */

/**
 * @author Andy Moody
 */
class SourceDestinationTypeCacheKey
{
	private Class<?> destinationType;
	private Object source;

	SourceDestinationTypeCacheKey(final Class<?> destinationType, final Object source)
	{
		this.destinationType = destinationType;
		this.source = source;
	}

	@Override
	public boolean equals(final Object o)
	{
		if (this == o)
		{
			return true;
		}
		if (o == null || getClass() != o.getClass())
		{
			return false;
		}

		SourceDestinationTypeCacheKey that = (SourceDestinationTypeCacheKey) o;

		if (destinationType != null ? !destinationType.equals(that.destinationType) : that.destinationType != null)
		{
			return false;
		}
		if (source != null ? !source.equals(that.source) : that.source != null)
		{
			return false;
		}

		return true;
	}

	@Override
	public int hashCode()
	{
		int result = destinationType != null ? destinationType.hashCode() : 0;
		result = 31 * result + (source != null ? source.hashCode() : 0);
		return result;
	}

	@Override
	public String toString()
	{
		return "SourceDestinationTypeCacheKey{" +
				"destinationType=" + destinationType +
				", source=" + source +
				'}';
	}
}
