package net.projectmonkey.object.mapper.util;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/*
 *
 *  * Copyright 2012 the original author or authors.
 *  *
 *  * Licensed under the Apache License, Version 2.0 (the "License");
 *  * you may not use this file except in compliance with the License.
 *  * You may obtain a copy of the License at
 *  *
 *  *      http://www.apache.org/licenses/LICENSE-2.0
 *  *
 *  * Unless required by applicable law or agreed to in writing, software
 *  * distributed under the License is distributed on an "AS IS" BASIS,
 *  * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  * See the License for the specific language governing permissions and
 *  * limitations under the License.
 *
 */

/**
 * @author Andy Moody
 */
public class Logger
{

	private final Log log;

	private Logger(Class<?> clazz)
	{
		this.log = LogFactory.getLog(clazz);
	}

	public void debug(String message, Object... args)
	{
		if(log.isDebugEnabled())
		{
			log.debug(String.format(message, args));
		}
	}

	public void warn(String message, Object... args)
	{
		if(log.isWarnEnabled())
		{
			log.warn(String.format(message, args));
		}
	}

	public void error(String message, Object... args)
	{
		if(log.isErrorEnabled())
		{
			log.error(String.format(message, args));
		}
	}

	public void info(String message, Object... args)
	{
		if(log.isInfoEnabled())
		{
			log.info(String.format(message, args));
		}
	}

	public static final Logger getLogger(Class<?> clazz)
	{
		return new Logger(clazz);
	}

}
