package net.projectmonkey.object.mapper.util;

/*
 *
 *  * Copyright 2012 the original author or authors.
 *  *
 *  * Licensed under the Apache License, Version 2.0 (the "License");
 *  * you may not use this file except in compliance with the License.
 *  * You may obtain a copy of the License at
 *  *
 *  *      http://www.apache.org/licenses/LICENSE-2.0
 *  *
 *  * Unless required by applicable law or agreed to in writing, software
 *  * distributed under the License is distributed on an "AS IS" BASIS,
 *  * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  * See the License for the specific language governing permissions and
 *  * limitations under the License.
 *
 */

import java.util.List;

/**
 * @author Andy Moody
 */
public class StringUtil
{

	public static String joinAll(final List<List<String>> strings, String separator)
	{
		StringBuilder propertyBuilder = new StringBuilder();

		for (int i = 0; i < strings.size(); i++)
		{
			propertyBuilder.append(join(strings.get(i), separator));
			if(i < strings.size() - 1)
			{
				propertyBuilder.append(separator);
			}
		}
		return propertyBuilder.toString();
	}

	public static String join(final List<String> strings, String separator)
	{
		StringBuilder tokenBuilder = new StringBuilder();
		for (int i = 0; i < strings.size(); i++)
		{
			tokenBuilder.append(strings.get(i));
			if(i < strings.size() - 1)
			{
				tokenBuilder.append(separator);
			}
		}
		return tokenBuilder.toString();
	}

}
